angular.module('starter')
    .controller('MatchCtrl', function($scope, $ionicSlideBoxDelegate, $timeout, $state, $ionicModal, $ionicPopup, toaster,
        UserService, HttpService, $ionicLoading, $ionicPlatform, $cordovaToast, $ionicScrollDelegate) {

        $scope.data = {};

        $scope.data.yourMatch = [];
        $scope.data.allMatches = [];

        $scope.data.opens = [];

        $scope.dates = [];
        currentActive = 1;

        $scope.data.slide = false;

        // LOI's slider

        $scope.isEmptyObject = function(obj) {
            for(var prop in obj) {
                if(obj.hasOwnProperty(prop))
                    return false;
            }
            return true;
        };

        $scope.doRefresh = function() {
            getMatchInfoList(currentActive);
        };

        $scope.$on("$ionicSlides.sliderInitialized", function(event, data){
            // data.slider is the instance of Swiper
            $scope.slider = data.slider;
        });

        $scope.$on("$ionicSlides.slideChangeStart", function(event, data){
            console.log('Slide change is beginning');
        });

        $scope.$on("$ionicSlides.slideChangeEnd", function(event, data){
            // note: the indexes are 0-based
            $scope.activeIndex = data.activeIndex;
            $scope.previousIndex = data.previousIndex;
        });

        $scope.$on('$ionicView.loaded', function() {
            getDisplayDates();
            onResume();
        });

        $scope.$on("onTabChanged", function(event, tab) {
            $scope.getUserData();
            $ionicScrollDelegate.scrollTop();
            if (tab == "match") {
                onResume();
            }
        });

        /*$scope.data.slideOptions = {
            direction: 'horizontal',
            slidesPerView: '1',
            paginationClickable: true,
            showNavButtons: true
        };

        $scope.data.sliderDelegate = null;
        $scope.$watch('data.sliderDelegate', function(newVal, oldVal) {
            if (newVal != null) {
                $scope.data.sliderDelegate.on('slideChangeEnd', function() {
                    $scope.data.currentPage = $scope.data.sliderDelegate.activeIndex;
                    //use $scope.$apply() to refresh any content external to the slider
                    $scope.$apply();
                });
            }
        });
        $scope.$on("$ionicSlides.sliderInitialized", function(event, data) {
            // grab an instance of the slider
            $scope.data.slider = data.slider;
            console.log("here " + $scope.data.slider);
        });*/

        $scope.openMatch = function() {
            $scope.data.slide = !$scope.data.slide;
        };

        $scope.goDetail = function(item) {
            $state.go('matchDetail', { matchId : item.info.matchId, match : item });
        };

        $ionicModal.fromTemplateUrl('./templates/modals/filter.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
        });
        $scope.openModal = function() {
            $scope.modal.show();
        };
        $scope.closeModal = function() {
            $scope.modal.hide();
        };

        $scope.getRateDisplay = getRateDisplay2dp;

        var getDisplayDates = function() {
            var date = new Date();
            date.setDate(date.getDate() - 1); // starting date is a day before
            var id = 0;
            do {
                var dayInWeek = {
                    "date": date.getDate(),
                    "day": DayInWeek[date.getDay()],
                    "timestamp": parseInt(date.getTime() / 1000),
                    "isActive": id === currentActive,
                    "isMatchDay": false,
                    "isBetDay": false,
                    "serverId": id - 1
                };
                $scope.dates.push(dayInWeek);
                date.setDate(date.getDate() + 1);
                id++;
            } while (id < 8);
            checkBetDay();
        };

        var getMatchInfoList = function(dateIndex) {
            console.log("get match list, token = " + UserService.getEzBetToken());
            var offset = getOffset();
            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/get_match_info_list",
                {"timestamp": $scope.dates[dateIndex].timestamp, "token": UserService.getEzBetToken(), "time_offset": offset},
                function(result) {
                    $scope.data.allLeagues = {};
                    $scope.data.leaguesInfo = {};
                    $scope.data.yourMatch = [];
                    if (!isNull(result.data.data)) {
                        for (var i = 0; i < result.data.data.length; i++) {
                            var tournament = result.data.data[i].tournament_id;
                            if (!$scope.data.allLeagues.hasOwnProperty(tournament)) {
                                $scope.data.allLeagues[tournament] = [];
                                $scope.data.leaguesInfo[tournament] = {
                                    "name": ALL_LEAGUE["League"][tournament - 1]["Name"],
                                    "img": 'img/icon/country/' + tournament + ".png",
                                    "isOpen": false
                                };
                            }
                        }
                        for (var i = 0; i < result.data.data.length; i++) {
                            var home_team = result.data.data[i].home_team;
                            var away_team = result.data.data[i].away_team;

                            var match = {
                                homeTeam: {
                                    name: ALL_TEAM[home_team].name,
                                    img: 'img/icon/team/' + ALL_TEAM[home_team].country + "_icon_crest_" + home_team + ".png",
                                    goal: result.data.data[i].home_goal
                                },
                                awayTeam: {
                                    name: ALL_TEAM[away_team].name,
                                    img: 'img/icon/team/' + ALL_TEAM[away_team].country + "_icon_crest_" + away_team + ".png",
                                    goal: result.data.data[i].away_goal
                                },
                                info: {
                                    matchId: result.data.data[i].match_id,
                                    oddHome: result.data.data[i].bet_odds[1].rate,
                                    oddDraw: result.data.data[i].bet_odds[0].rate,
                                    oddAway: result.data.data[i].bet_odds[2].rate,
                                    startTime: convertUnixToDisplayTime(result.data.data[i].start_time),
                                    matchTime: result.data.data[i].match_time,
                                    matchFlag: result.data.data[i].flag,
                                    isBet: result.data.data[i].is_bet
                                }
                            };
                            if (match.info.isBet) {
                                $scope.data.yourMatch.push(match);
                            } else {
                                $scope.data.allLeagues[result.data.data[i].tournament_id].push(match);
                            }
                        }
                        for (var i in $scope.data.allLeagues) {
                            if ($scope.data.allLeagues[i].length == 0) {
                                delete $scope.data.allLeagues[i];
                                i--;
                            }
                        }
                        $scope.data.opens = [];
                        var first = true;
                        for (var i in $scope.data.allLeagues) {
                            $scope.data.opens.push(first);
                            first = false;
                        }
                    }
                    console.log("your match = " + JSON.stringify($scope.data.yourMatch));
                    $scope.data.displayAllMatch = Object.keys($scope.data.allLeagues).length>0;
                    $scope.$broadcast('scroll.refreshComplete');
                    $ionicLoading.hide();
                    //console.log("hehe " + $ionicSlideBoxDelegate.slidesCount()+" " + $ionicSlideBoxDelegate.currentIndex());
                    //console.log("league = " + JSON.stringify($scope.data.allLeagues));
                    //console.log("info = " + JSON.stringify($scope.data.leaguesInfo));
                },
                function(error) {
                    $cordovaToast.show('Không tải được trận đấu', 'short', 'bottom');
                    $scope.$broadcast('scroll.refreshComplete');
                    $ionicLoading.hide();
                    console.log("error /get_match_info_list: " + JSON.stringify(error));
                },
                1
            );
        };

        var checkBetDay = function() {
            var offset = getOffset();
            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/get_day_flag",
                {"timestamp": getCurrentTimestamp(), "low_day_count": 1, "high_day_count": 6, "token": UserService.getEzBetToken(), "time_offset": offset},
                function(result) {
                    if (!isNull(result.data.data)) {
                        for (var i in result.data.data) {
                            for (var j = 0; j < $scope.dates.length; j++) {
                                if ($scope.dates[j].serverId == i) {
                                    $scope.dates[j].isMatchDay = result.data.data[i].has_match;
                                    $scope.dates[j].isBetDay = result.data.data[i].has_bet;
                                }
                            }
                        }
                    }
                },
                function(error) {
                    console.log("error /check_bet_day: " + JSON.stringify(error));
                },
                3
            );
        };

        $scope.changeDate = function(dateIndex) {
            $ionicScrollDelegate.scrollTop();
            if (dateIndex == currentActive) {
                return;
            }
            $scope.dates[currentActive].isActive = false;
            currentActive = dateIndex;
            $scope.dates[currentActive].isActive = true;
            $ionicLoading.show();
            getMatchInfoList(currentActive);
        };

        $scope.refreshMatch = function() {
            console.log("refreshing");
            getMatchInfoList(currentActive);
        };

        $ionicPlatform.on("resume", function() {
            if (UserService.isLoggedIn()) {
                onResume();
            }
        });

        var onResume = function() {
            console.log("onresume match");
            $ionicLoading.show();
            getMatchInfoList(currentActive);
            $scope.getUnreadNotification();
        };

        $scope.changeOpen = function(i) {
            if ($scope.data.opens[i] == true) {
                for (var j in $scope.data.opens) {
                    if (i != j)
                        $scope.data.opens[j] = false;
                }
            }
            $ionicScrollDelegate.scrollTop();
        }
    });
