angular.module('starter')
    .controller('MatchDetailCtrl', function($scope, $ionicPopup, $ionicModal, toaster, $stateParams, UserService, $http,
        $templateCache, $timeout, $cordovaToast, HttpService, $ionicLoading, $ionicScrollDelegate) {
        if (isNull($stateParams.matchId)) {
            console.log("null matchId");
            return;
        }

        $scope.data = {};

        $scope.data.match = $stateParams.match;

        $scope.data.displayBet = true;

        $scope.data.amountList = [100, 200, 500, 1000, 2000, 3000, 4000, 5000];

        $scope.data.betOptions = {};
        $scope.data.betDisplays = [];

        $scope.data.opens = [];

        $scope.data.events = [];

        $ionicLoading.show({
            template: 'Loading'
        });

        $scope.data.tabs = [{
            img: './img/bet.png',
            imgActive: './img/bet-active.png',
            id: 1
        }, {
            img: './img/match.png',
            imgActive: './img/match-active.png',
            id: 2
        }, {
            img: './img/squad.png',
            imgActive: './img/squad-active.png',
            id: 4
        }, {
            img: './img/stats.png',
            imgActive: './img/stats-active.png',
            id: 3
        }, {
            img: './img/media.png',
            imgActive: './img/video-active.png',
            id: 5
        }];

        $ionicModal.fromTemplateUrl('./templates/modals/new_detail.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
        });
        $scope.openModal = function() {
            $scope.modal.show();
        };
        $scope.closeModal = function() {
            $scope.modal.hide();
        };
        $scope.doRefresh = function() {
            console.log('pull to refresh');
            $timeout(function () {
                getMatchDetailAndSquad();
                $scope.$broadcast('scroll.refreshComplete');
            }, 3000)
        };

        $scope.selectTab = function(item) {
            $ionicScrollDelegate.scrollTop();
            $scope.data.tabSelected = item;
        };

        $scope.selectTab($scope.data.tabs[0]);

        $scope.data.isOpen = [false, false, false, false, false, false, false, false];

        $scope.getRateDisplay = getRateDisplay2dp;

        $scope.data.bet = {};
        $scope.changeBet = function(value) {
            $scope.data.bet.amount = value;
            $scope.onBetAmountChanged();
        };
        $scope.onBetAmountChanged = function() {
            if (isNull($scope.data.bet.amount)) {
                $scope.data.bet.possibleWin = "";
            } else if (!isNumberValid($scope.data.bet.amount)) {
                $scope.data.bet.possibleWin = "Không hợp lệ";
            } else {
                $scope.data.bet.possibleWin = $scope.data.bet.amount * $scope.data.bet.rate / 100;
            }
        };

        $scope.$on('$ionicView.loaded', function() {
            getMatchDetailAndSquad();
        });

        $scope.showPopup = function(bet) {
            if ($scope.data.match.flag == 2) {
                $cordovaToast.show('Không thể đặt: trận đấu đang diễn ra', 'short', 'bottom');
                return;
            } else if ($scope.data.match.flag == 3) {
                $cordovaToast.show('Không thể đặt: trận đấu đã kết thúc', 'short', 'bottom');
                return;
            }
            $scope.data.bet.betId = bet.bet_id;
            $scope.data.bet.rate = bet.rate;
            var myPopup = $ionicPopup.show({
                templateUrl: './templates/modals/bet.html',
                scope: $scope,
                cssClass: 'bet-popup',
                buttons: [{
                    text: 'Huỷ',
                    type: 'button-default',
                    onTap: function(e) {
                        return 0;
                    }
                }, {
                    text: 'Đặt',
                    type: 'button-positive',
                    onTap: function(e) {
                        return 1;
                    }
                }]
            });

            myPopup.then(function(res) {
                if (res === 1) {
                    if (!isNumberValid($scope.data.bet.amount)) {
                        toaster.error({
                            body: "Số xu không hợp lệ",
                            timeout: 500
                        });
                    } else if ($scope.data.bet.amount < 100) {
                        toaster.error({
                            body: "Đặt ít nhất 100 xu",
                            timeout: 500
                        });
                    } else {
                        placeBet();
                    }
                }
            });
        };

        var placeBet = function() {
            var data = {
                "rate": $scope.data.bet.rate,
                "amount": $scope.data.bet.amount,
                "bet_id": $scope.data.bet.betId,
                "token": UserService.getEzBetToken()
            };

            $ionicLoading.show();
            // Cannot use HttpService because response can be successful but result.data.result != SUCCESS
            $http({
                method: "POST",
                url: "http://www.ezbet.online/api/place_bet",
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded"
                },
                data: toQueryString(data)
            }).then(function(result) {
                if ("result" in result.data) {
                    switch(result.data.result) {
                        case ResultCode.SUCCESS:
                            $scope.animateIcon(2);
                            toaster.success({
                                body: "Đặt thành công",
                                timeout: 500
                            });
                            break;
                        case ResultCode.ERROR_BET_NOT_EXIST:
                            toaster.error({
                                body: "Không hợp lệ",
                                timeout: 500
                            });
                            break;
                        case ResultCode.ERROR_BET_RATE_MISMATCH:
                            toaster.error({
                                body: "Không hợp lệ",
                                timeout: 500
                            });
                            break;
                        case ResultCode.ERROR_NOT_ENOUGH_COIN:
                            toaster.error({
                                body: "Bạn không có đủ xu",
                                timeout: 500
                            });
                            break;
                        case ResultCode.ERROR_MATCH_HAPPENING:
                            toaster.error({
                                body: "Trận đấu đang diễn ra",
                                timeout: 500
                            });
                            break;
                        case ResultCode.ERROR_MATCH_DUPLICATE_BET:
                            toaster.error({
                                body: "Bạn đã cược trận này rồi",
                                timeout: 500
                            });
                            break;
                    }
                    getMatchBetInfo();
                    $scope.getUserData();
                }
                $ionicLoading.hide();
            }, function(error) {
                $cordovaToast.show('Không thể đặt: lỗi mạng', 'short', 'bottom');
                $ionicLoading.hide();
            });
        };

        var getMatchBetInfo = function() {
            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/get_match_bet_info",
                {"match_id": $stateParams.matchId, "token": UserService.getEzBetToken()},
                function(result) {
                    console.log("THÔNG TIN CƯỢC: ", result);
                    $scope.data.displayBet = false;
                    if ($scope.data.match.info.matchFlag == 1)
                        $scope.data.displayBet = true;
                    if (!isNull(result.data.data) && !isNull(result.data.data.bet_options)) {
                        $scope.data.betOptions = result.data.data.bet_options;
                        $scope.data.betDisplays = [];
                        for (var i = 0; i < BetOptionOrder.length; i++) {
                            var type = BetOptionOrder[i];
                            if (isNull($scope.data.betOptions[type])) {
                                continue;
                            }

                            // console.log("options = " + type + ": " + JSON.stringify($scope.data.betOptions[type]));

                            if (type == 1 || type == 6) {
                                continue;
                            }

                            $scope.data.betOptions[type].sort(getBetOptionSortingFunction(type));

                            // console.log("options = " + type + ": " + JSON.stringify($scope.data.betOptions[type]));
                            var display = {
                                betName: BetOptionName[type],
                                absChange: 0,
                                betFlag: 0,
                                betType: type,
                                has_bet: false
                            };
                            var isPending = false;
                            for (var j = 0; j < $scope.data.betOptions[type].length; j++) {
                                if ($scope.data.betOptions[type][j].hasOwnProperty('current_bet')) {
                                    display.has_bet = true;
                                    $scope.data.displayBet = true;
                                    display.absChange += $scope.data.betOptions[type][j].current_bet.bet_return - $scope.data.betOptions[type][j].current_bet.bet_amount;

                                    if ($scope.data.betOptions[type][j].current_bet.bet_flag == 0) {
                                        isPending = true;
                                    }
                                }
                            }
                            if (isPending) {
                                display.betFlag = 0;
                                display.absChange = 0;
                            } else {
                                display.betFlag = (display.absChange >= 0) ? 2 : 3;
                                display.absChange = Math.abs(display.absChange);
                            }
                            $scope.data.betDisplays.push(display);
                        }
                        $scope.data.opens = [];
                        var first = true;
                        for (var i in $scope.data.betDisplays) {
                            $scope.data.opens.push(first);
                            first = false;
                        }
                    }
                    $ionicLoading.hide();
                },
                function(error) {
                    $ionicLoading.hide();
                    console.log("error /get_match_bet_info: " + JSON.stringify(error));
                },
                3
            );
        };

        var getMatchDetailAndSquad = function() {
            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/get_match_details",
                {"match_id": $stateParams.matchId, "token": UserService.getEzBetToken()},
                function(result) {
                    console.log("details: ", result);

                    $scope.data.events = [];

                    var home_team = result.data.data.match_info.home_team;
                    var away_team = result.data.data.match_info.away_team;

                    $scope.data.match = {
                        homeTeam: {
                            name: ALL_TEAM[home_team].name,
                            img: 'img/icon/team/' + ALL_TEAM[home_team].country + "_icon_crest_" + home_team + ".png",
                            goal: result.data.data.match_info.home_goal
                        },
                        awayTeam: {
                            name: ALL_TEAM[away_team].name,
                            img: 'img/icon/team/' + ALL_TEAM[away_team].country + "_icon_crest_" + away_team + ".png",
                            goal: result.data.data.match_info.away_goal
                        },
                        info: {
                            matchId: result.data.data.match_info.match_id,
                            startTime: convertUnixToDisplayTime(result.data.data.match_info.start_time),
                            matchTime: result.data.data.match_info.match_time,
                            matchFlag: result.data.data.match_info.flag
                        }
                    };

                    $scope.data.events.push({
                        team: "home",
                        type: "start",
                        time: 0,
                        name: "start"
                    });

                    function getEvent(events, detailStr, type, team) {
                        if (!detailStr) return;
                        var details = detailStr.split(";");
                        if (type != 'sub') {
                            for (var i = 0; i < details.length; i++) {
                                var detail = details[i];
                                var splits = detail.split(":");
                                if (splits.length == 2) {
                                    var time = parseInt(splits[0].trim().slice(0, -1));
                                    var name = splits[1].trim();
                                    events.push({
                                        team: team,
                                        type: type,
                                        time: time,
                                        name: name
                                    });
                                }
                            }
                        }
                        else {
                            for (i = 0; i < details.length; i += 2) {
                                if (i >= details.length - 1) break;
                                var name1 = "";
                                var name2 = "";
                                var subTime = 0;
                                for (var j = i; j <= i + 1; j ++) {
                                    detail = details[j];
                                    splits = detail.split(":");
                                    if (splits.length == 2) {
                                        subTime = parseInt(splits[0].trim().slice(0, -1));
                                        var modeAndName = splits[1].trim();
                                        var k = modeAndName.indexOf(' ');
                                        var splitsSecond = [modeAndName.slice(0, k), modeAndName.slice(k + 1)];
                                        if (splitsSecond[0] == 'in') name1 = splitsSecond[1];
                                        else name2 = splitsSecond[1];
                                    }
                                }
                                if (name1 != "" && name2 != "")
                                    events.push({
                                        team: team,
                                        type: type,
                                        time: subTime,
                                        name: name1,
                                        name2: name2
                                    });

                            }
                        }
                    }

                    try {
                        getEvent($scope.data.events, result.data.data.highlight.homeGoal, "goal", "home");
                        getEvent($scope.data.events, result.data.data.highlight.homeSub, "sub", "home");
                        getEvent($scope.data.events, result.data.data.highlight.homeYellow, "yellow", "home");
                        getEvent($scope.data.events, result.data.data.highlight.homeRed, "red", "home");
                        getEvent($scope.data.events, result.data.data.highlight.awayGoal, "goal", "away");
                        getEvent($scope.data.events, result.data.data.highlight.awaySub, "sub", "away");
                        getEvent($scope.data.events, result.data.data.highlight.awayYellow, "yellow", "away");
                        getEvent($scope.data.events, result.data.data.highlight.awayRed, "red", "away");
                    }
                    catch(err) {
                        console.log(err)
                    }
                    $scope.data.events.sort(function(a, b){
                        if (a.type == "start") return -1;
                        if (a.time == b.time) {
                            if (a.type == b.type) {
                                if (a.team == b.team)
                                    return a.name < b.name ? -1 : 1;
                                else return a.team < b.team ? -1 : 1;
                            }
                            else return a.type < b.type ? -1 : 1;
                        }
                        else return a.time - b.time;
                    });

                    function getPlayers(playerStr) {
                        var playerList = [];
                        if (!playerStr) return;
                        var details = playerStr.split(";");
                        for (var i = 0; i < details.length; i++) {
                            var detail = details[i];
                            detail = detail.trim();
                            if (detail.length > 0) {
                                var words = detail.split(' ');
                                playerList.push(words[words.length - 1]);
                            }
                        }
                        return playerList;
                    }

                    function getSquad(squad) {
                        var homeGoal = getPlayers(squad.goalkeepers);
                        var homeDef = getPlayers(squad.defenders);
                        var homeMid = getPlayers(squad.midfielders);
                        var homeFor = getPlayers(squad.forwards);

                        var alter = false;
                        while (homeMid && homeMid.length > 5) {
                            if (alter)
                                homeFor.push(homeMid.splice(-1, 1)[0]);
                            else
                                homeFor.unshift(homeMid.splice(0, 1)[0]);
                            alter = !alter;
                        }

                        return {
                            goalkeepers: homeGoal,
                            defenders: homeDef,
                            midfielders: homeMid,
                            forwards: homeFor
                        };

                    }

                    Array.prototype.extend = function (other_array) {
                        /* you should include a test to check whether other_array really is an array */
                        if (!isNull(other_array)) {
                            other_array.forEach(function(v) {this.push(v)}, this);
                        }
                    };

                    function getLines(squad, formation, reverse) {
                        var lines = [];
                        var players = [];
                        players.extend(squad.defenders);
                        players.extend(squad.midfielders);
                        players.extend(squad.forwards);
                        var lineNums = formation.split('-');
                        var counter = 0;
                        for(var i = 0; i < lineNums.length; i ++) {
                            var lineNum = parseInt(lineNums[i]);
                            var line = [];
                            for(var k = 0; k < lineNum; k ++)
                                line.push(players[counter ++]);
                            if (reverse)
                                line.reverse();
                            if (i == lineNums.length - 2 && lines.length < 2)
                                lines.push([]);
                            lines.push(line);
                        }

                        return lines;
                    }

                    $scope.data.homeSquad = getSquad(result.data.data.squad.home);
                    $scope.data.awaySquad = getSquad(result.data.data.squad.away);
                    $scope.data.homeLines = getLines($scope.data.homeSquad, result.data.data.highlight.homeFormation, false);
                    $scope.data.awayLines = getLines($scope.data.awaySquad, result.data.data.highlight.awayFormation, true);

                    getMatchBetInfo();
                },
                function(error) {
                    console.log("error /get_match_details: " + JSON.stringify(error));
                },
                3
            );
        };

        $scope.changeOpen = function(i) {
            if ($scope.data.opens[i] == true) {
                for (var j in $scope.data.opens) {
                    if (i != j)
                        $scope.data.opens[j] = false;
                }
            }
        };

        getMatchDetailAndSquad();
    })
    .directive('betOption', function() {
        return {
            restrict: 'E',
            link: function(scope, element, attrs) {
                scope.getBetTypeUrl = '';
                attrs.$observe('type', function(value) {
                    scope.getBetTypeUrl = BetOptionTemplateUrl[value];
                });
            },
            template: '<div><p ng-include="getBetTypeUrl"></p></div>'
        }
    });
