
angular.module('starter')
    .controller('MissionCtrl', function ($scope, $rootScope, $ionicPopup, $ionicModal, $cordovaToast, UserService, toaster, HttpService) {

        $scope.data = {};
        $scope.data.user = UserService.getUserProfile();
        $scope.data.code = "";
        $scope.tabActive = 0;

        $scope.exLink = function (url){
            window.open(encodeURI(url), '_system', 'location=yes');
        };

        $rootScope.updateMissionList = function() {
            /*
            data = {
                bonus_class: BonusClass.BONUS_CLASS_MISSION,
                token: UserService.getEzBetToken()
            };

            $http({
                method: "POST",
                url: "http://www.ezbet.online/api/get_bonus_list",
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded"
                },
                data: toQueryString(data)
            }).then(function(result) {
                $scope.data.bonus_list = result.data.data;
                console.log("Bonus list: ", $scope.data.bonus_list);
            });
            */

            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/get_bonus_list",
                {"bonus_class": BonusClass.BONUS_CLASS_MISSION, "token": UserService.getEzBetToken()},
                function(result) {
                    $scope.data.bonus_list = result.data.data;
                    for (var i = 0; i < $scope.data.bonus_list.length; i++) {
                        var type = $scope.data.bonus_list[i].type;
                        $scope.data.bonus_list[i].icon = BonusType[type].icon;
                        $scope.data.bonus_list[i].name = BonusType[type].name;
                        $scope.data.bonus_list[i].description = BonusType[type].description;
                    }
                    $scope.$emit("updateMissionList", "succeeded");
                    console.log("Bonus list: ", $scope.data.bonus_list);
                },
                function(error) {
                    $scope.$emit("updateMissionList", "failed");
                    console.log("error: " + JSON.stringify(error));
                },
                3
            );

        };

        $scope.getMissionReward = function(bonus) {
            console.log("Try to get bonus: ", bonus);
            if (bonus.type == BonusTypeCode.BONUS_MISSION_INVITE_FRIEND)
            {
                toaster.success({
                    body: "Gửi mã \"" + bonus.data +"\" cho bạn bè để lấy thưởng",
                    timeout: 1000
                })
                return;
            }
            if (bonus.flag != 2) {
                toaster.error({
                    body: "Bạn không đủ điều kiện để lấy thưởng",
                    timeout: 500
                });
                return;
            }

            /*
            data = {
                bonus_type: bonus.type,
                token: UserService.getEzBetToken()
            };
            $http({
                method: "POST",
                url: "http://www.ezbet.online/api/claim_bonus",
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded"
                },
                data: toQueryString(data)
            }).then(function(result) {
                console.log(result);
                if (result.data.result == 0) {
                    $scope.getUserData();
                    $rootScope.updateMissionList();
                }
            });*/

            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/claim_bonus",
                {"bonus_type": bonus.type, "token": UserService.getEzBetToken()},
                function(result) {
                    if (result.data.result == 0) {
                        $scope.getUserData();
                        $rootScope.updateMissionList();
                    }
                },
                function(error) {
                    $cordovaToast.show("Không lấy được thưởng", "short", "bottom");
                    console.log("error: " + JSON.stringify(error));
                },
                3
            );
        };

        $scope.updateTab = function(tabNo) {
            $scope.tabActive = tabNo;
        }

        $scope.applyCode = function() {
            code = $scope.data.code.trim();
            if (code == "")
            {
                toaster.error({
                    body: "Nhập mã giới thiệu!",
                    timeout: 500
                });
                return;
            }

            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/add_promotion_code",
                {"promotion_code": code, "token": UserService.getEzBetToken()},
                function(result) {
                    if (result.data.result == 0) {
                        $scope.getUserData();
                        //$rootScope.updateMissionList();
                    }
                },
                function(error) {
                    var result_code = error.data.result;
                    var msg = "không dùng được mã!";
                    if (result_code == ResultCode.ERROR_PROMO_ADD_HIMSELF) {
                        msg = "mã không hợp lệ!";
                    } else if (result_code == ResultCode.ERROR_PROMO_CODE_INVALID) {
                        msg = "mã không hợp lệ!";
                    } else if (result_code = ResultCode.ERROR_PROMO_ALREADY_ACCEPT_INVITATION) {
                        msg = "mã đã được sử dụng!";
                    }
                    $cordovaToast.show(msg, "short", "bottom");
                    console.log("error: " + JSON.stringify(error));
                },
                3
            );
        }
    });
