
angular.module('starter')
    .controller('MoreCtrl', function ($scope, $ionicModal, $state, UserService, $http, HttpService, $cordovaToast, $ionicPlatform, $ionicLoading) {

        $scope.data = {};
        $ionicModal.fromTemplateUrl('./templates/modals/profile.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
        });
        $scope.openModal = function() {
            $scope.modal.show();
        };
        $scope.closeModal = function() {
            $scope.modal.hide();
        };
        $scope.data.tabActive = false;

        $scope.activeTab = function (active) {
            $scope.updateActiveTabShop(active)
        };

        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
            //console.log(event, viewData)
            viewData.enableBack = false;
        });

        $scope.$on('$ionicView.loaded', function() {
            onResume();
        });

        $scope.$on("onTabChanged", function(event, tab) {
            if (tab == "more") {
                onResume();
            }
        });

        $scope.logOut = function() {
            UserService.logOut();
            $state.go("login");
        };

        $scope.data.user = UserService.getUserProfile();

        var getUserInfo = function() {
            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/get_user_info",
                {"version": UserService.getUserVersion(), "token": UserService.getEzBetToken()},
                function(result) {
                    if (!isNull(result.data.data)) {
                        console.log("saving, hehe");
                        $scope.data.user = result.data.data;
                        UserService.setUserProfile(result.data.data);
                    }
                },
                function(error) {
                    $cordovaToast.show('Không lấy được thông tin người dùng', 'short', 'bottom');
                    console.log("error /get_user_info: " + JSON.stringify(error));
                },
                3
            );
        };

        var getUserStats = function() {
            console.log("get user stats, token = " + UserService.getEzBetToken());
            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/get_user_stats",
                {"token": UserService.getEzBetToken()},
                function(result) {
                    if (!isNull(result.data.data)) {
                        $scope.data.rank = parseInt(result.data.data.rank);
                        $scope.data.win = parseInt(result.data.data.win);
                        $scope.data.lose = parseInt(result.data.data.lose);
                        if ($scope.data.win + $scope.data.lose === 0) {
                            $scope.data.rate = 0;
                        } else {
                            $scope.data.rate = Math.round($scope.data.win * 100.0 / ($scope.data.win + $scope.data.lose));
                        }
                    }
                    $ionicLoading.hide();
                },
                function(error) {
                    $cordovaToast.show('Không lấy được thông tin người dùng', 'short', 'bottom');
                    $ionicLoading.hide();
                    console.log("error /get_user_stats: " + JSON.stringify(error));
                },
                3
            );
        }

        $ionicPlatform.on("resume", function() {
            if (UserService.isLoggedIn()) {
                onResume();
            }
        });

        var onResume = function() {
            console.log("onresume more");
            $ionicLoading.show();
            getUserInfo();
            getUserStats();
        };
    });
