
angular.module('starter')
    .controller('NewsCtrl', function ($scope, $ionicSlideBoxDelegate, $ionicModal, $http, UserService, $ionicPlatform, $ionicLoading, HttpService) {

        $scope.data = {};

        $ionicModal.fromTemplateUrl('./templates/modals/news_detail.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
        });
        $scope.openModal = function(news) {
            data = {
                news_id: news.id,
                token: UserService.getEzBetToken()
            };
            $http({
                method: "POST",
                url: "http://www.ezbet.online/api/get_news_details",
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded"
                },
                data: toQueryString(data)
            }).then(function(result) {
                $scope.detail = result.data.data;
                $scope.modal.show();
            });
        };
        $scope.closeModal = function() {
            $scope.modal.hide();
        };

        $scope.$on('$ionicView.loaded', function() {
            onResume();
        });

        $scope.$on("onTabChanged", function(event, tab) {
            if (tab == "news") {
                //onResume();
            }
        });

        $scope.doRefresh = function() {
            onResume();
        };

        var updateNewsApi = function() {
            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/get_news_list",
                {"news_count": 10, "token": UserService.getEzBetToken()},
                function(result) {
                    $scope.data.news = result.data.data;
                    $ionicSlideBoxDelegate.update();
                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.refreshComplete');
                },
                function(error) {
                    $cordovaToast.show('Cannot load news', 'short', 'bottom');
                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.refreshComplete');
                },
                3
            );
        }

        $ionicPlatform.on("resume", function() {
            if (UserService.isLoggedIn()) {
                onResume();
            }
        });

        var onResume = function() {
            console.log("onresume news");
            $ionicLoading.show();
            updateNewsApi();
        };
    });
