
angular.module('starter')
    .controller('RankingCtrl', function ($scope, $ionicSlideBoxDelegate, $ionicModal, $ionicPopup, $http, UserService, $ionicPlatform, $ionicLoading, HttpService) {

        $scope.data = {};

        $scope.data.active = 3;

        $scope.$on('$ionicView.loaded', function() {
            onResume();
        });

        $scope.$on("onTabChanged", function(event, tab) {
            $scope.getUserData();
            if (tab == "ranking") {
                onResume();
            }
        });

        $scope.updateRank = function(type) {
            $ionicLoading.show();
            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/get_rank_list",
                {rank_type: type, token: UserService.getEzBetToken()},
                function(result) {
                    if (!isNull(result.data.data)) {
                        $scope.data.rank_high = result.data.data['high_list'];
                        $scope.data.rank_low = result.data.data['low_list'];
                    }
                    $ionicLoading.hide();
                    console.log(result);
                },
                function(error) {
                    $ionicLoading.hide();
                    console.log("error /get_rank_list: " + JSON.stringify(error));
                },
                3
            );
        };

        $scope.changeActive = function(type) {
            $scope.data.active = type;
            $scope.updateRank($scope.data.active);
        };

        $ionicPlatform.on("resume", function() {
            if (UserService.isLoggedIn()) {
                onResume();
            }
        });

        var onResume = function() {
            console.log("onresume ranking");
            $ionicLoading.show();
            $scope.updateRank($scope.data.active);
        };
    })
    .filter('timestamp_to_time', function() {
        return function(timestamp) {
            var date = new Date(timestamp*1000);
            var hours = "0" + date.getHours();
            var minutes = "0" + date.getMinutes();
            return hours.substr(-2) + ':' + minutes.substr(-2);
        }
    })
    .filter('timestamp_to_date', function() {
        return function(timestamp) {
            var date = new Date(timestamp*1000);
            var day = "0" + date.getDate();
            var month = "0" + date.getMonth();
            var year = "0" + date.getFullYear();
            return day.substr(-2) + '/' + month.substr(-2) + '/' + year.substr(-2);
        }
    })
    .filter('shorten_name', function() {
        return function(name) {
            if (name.length > 20) {
                name = name.substr(0, 15);
                name = name + "..."
            }
            return name
        }
    });
