angular.module('starter')
	.controller('RedeemCtrl', function ($scope, $ionicPopup, $ionicModal, $http, UserService, $ionicPlatform, $ionicLoading, toaster) {

		$scope.data = {};
		$scope.data.user = UserService.getUserProfile();

		$scope.showPopup = function (item) {
			var myPopup = $ionicPopup.show({
				title: '<div><img src="'+ item.icon + '" class="redeem-image-popup"></div><div><strong class="green">Redeem</strong></div>',
				subTitle: item.price + ' <img src="./img/coin.png" width="10" height="10"> for ' + item.description + '<br/>Quà sẽ được gửi đến ' + $scope.data.user.email,
				cssClass: 'redeem-pop-up',
				scope: $scope,
				buttons: [
					{text: 'Huỷ'},
					{
						text: 'Xác nhận',
						type: 'button-positive bg-green',
						onTap: function (e) {
							data = {
								redeem_item_id: item.item_id,
								token: UserService.getEzBetToken()
							};
							$http({
								method: "POST",
								url: "http://www.ezbet.online/api/redeem",
								headers: {
									"Content-Type": "application/x-www-form-urlencoded"
								},
								data: toQueryString(data)
							}).then(function (result) {
								if (result.data.result != 0)
									toaster.error({
										body: "Bạn không đủ xu.",
										timeout: 200
									});
								else
									$scope.showPopupSuccess(item);
							});
						}
					}
				]
			});
		};

		$scope.showPopupSuccess = function (item) {
			var myPopup = $ionicPopup.show({
				title: '<div><div><img src="'+ item.icon + '" class="redeem-image-popup"></div><div><strong class="green">Chúc mừng</strong></div>',
				subTitle: 'Bạn đã nhận được ' + item.description,
				cssClass: 'redeem-pop-up',
				scope: $scope,
				buttons: [
					{
						text: 'Cám ơn',
						type: 'button-positive bg-green',
						onTap: function (e) {
							$scope.getUserData();
						}
					}
				]
			});
		};

		$scope.$on('$ionicView.loaded', function () {
			updateRedeemList();
		});

		$scope.$on("onTabChanged", function(event, tab) {
			$scope.getUserData();
			if (tab == "redeem") {
				onResume();
			}
		});

		var updateRedeemList = function () {
			data = {
				news_count: 10,
				token: UserService.getEzBetToken()
			};
			$http({
				method: "POST",
				url: "http://www.ezbet.online/api/get_redeem_item_list",
				headers: {
					"Content-Type": "application/x-www-form-urlencoded"
				},
				data: toQueryString(data)
			}).then(function (result) {
				$scope.data.redeem_list = result.data.data;
				for (var type in $scope.data.redeem_list) {
					$scope.data.redeem_list[type]['open'] = true;
					break;
				}
				console.log($scope.data.redeem_list);
				$ionicLoading.hide();
			});
		}

		$ionicPlatform.on("resume", function() {
            onResume();
        });

        var onResume = function() {
            console.log("onresume redeem");
            $ionicLoading.show();
			updateRedeemList();
        };
	});
