
angular.module('starter')
    .controller('HistoryCtrl', function ($scope, $ionicSlideBoxDelegate, $ionicModal, $ionicPopup, $http, UserService, $ionicPlatform) {


        $scope.data = {};
        $scope.data.item_list = [];
        $scope.data.hasMoreSlips = true;
        $scope.data.hasNoSlips = true;
        $scope.from_id = 0;
        $scope.limit = 10;

        $scope.$on('$ionicView.loaded', function() {
            $scope.updateNewsApi();
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            console.log("entering...");
            $scope.data.item_list = [];
            $scope.from_id = 0;
            $scope.data.hasMoreSlips = true;
            $scope.data.hasNoSlips = true;
            $scope.limit = 10;
            $scope.updateNewsApi();
        });

        $scope.updateNewsApi = function() {
            data = {
                from_id: $scope.from_id,
                limit: $scope.limit,
                token: UserService.getEzBetToken()
            };
            $http({
                method: "POST",
                url: "http://www.ezbet.online/api/get_redeem_history",
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded"
                },
                data: toQueryString(data)
            }).then(function(result) {
                console.log("REDEEM HISTORY: ", result.data, " from ID: ", $scope.from_id, "limit: ", $scope.limit);
                if ("result" in result.data && result.data.result === ResultCode.SUCCESS && !isNull(result.data.data)) {
                    $scope.data.item_list = $scope.data.item_list.concat(result.data.data);
                    for (var i = 0; i < $scope.data.item_list.length; i ++) {
                        $scope.data.hasNoSlips = false;
                        var item = $scope.data.item_list[i];
                        $scope.from_id = item.id
                    }
                    $scope.data.hasMoreSlips = true;
                }
                else {
                    $scope.data.hasMoreSlips = false;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }, function (error) {
                console.log("error /get_redeem_history: " + JSON.stringify(error));
                $scope.data.hasMoreSlips = false;
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        };

        $scope.showItemStatus = function (item) {
            if (item.status == 2) {
                $ionicPopup.show({
                    title: '<strong class="green"> Đã lấy quà </strong>',
                    subTitle: "Dùng mã ở bên dưới <br><b>" + item.data + "</b>",
                    cssClass: 'redeem-history-pop-up',
                    scope: $scope,
                    buttons: [
                        {
                            text: 'Biết rồi',
                            type: 'button-positive bg-green',
                            onTap: function (e) {

                            }
                        }
                    ]
                });
            }
            else {
                $ionicPopup.show({
                    title: '<strong class="yellow"> Đang xử lý </strong>',
                    subTitle: 'Chúng tôi đang xử lý yêu cầu của bạn.',
                    cssClass: 'redeem-history-pop-up',
                    scope: $scope,
                    buttons: [
                        {
                            text: 'Biết rồi',
                            type: 'button-positive bg-yellow',
                            onTap: function (e) {

                            }
                        }
                    ]
                });
            }
        };
        $ionicPlatform.on("resume", function() {
            updateNewsApi();
        });
    })
    .filter('timestamp_to_time', function() {
        return function(timestamp) {
            var date = new Date(timestamp*1000);
            var hours = "0" + date.getHours();
            var minutes = "0" + date.getMinutes();
            return hours.substr(-2) + ':' + minutes.substr(-2);
        }
    })
    .filter('timestamp_to_real_date', function() {
        return function(timestamp) {
            var date = new Date(timestamp*1000);
            var day = "0" + date.getDate();
            var month = "0" + (date.getMonth() + 1);
            var year = "0" + date.getFullYear();
            return day.substr(-2) + '/' + month.substr(-2) + '/' + year.substr(-2);
        }
    });
