
angular.module('starter')
    .controller('SlipsCtrl', function ($scope, $ionicScrollDelegate, $timeout, $state, $http, UserService, $ionicPlatform, $ionicLoading, HttpService) {

        $scope.data = {};

        $scope.data.slipDays = {};
        $scope.data.hasMoreSlips = true;

        var lastStartTime = null;
        var matchIdSet = {};

        $scope.$on('$ionicView.loaded', function () {
            onResume();
		});

		$scope.$on("onTabChanged", function(event, tab) {
            $scope.getUserData();
			if (tab == "slips") {
				onResume();
			}
		});

        $scope.goDetail = function(slip) {
            $state.go('slipsDetail', { matchId : slip.info.matchId, match : slip });
        }

        $scope.loadMore = function() {
            console.log("triggered");
            getSlipList(lastStartTime);
        };

        var getSlipList = function(fromTime) {
            console.log("query start time = " + fromTime);
            var data = {
                "token": UserService.getEzBetToken()
            };
            if (!isNull(fromTime)) {
                data["from_match_start_time"] = fromTime;
            }

            HttpService.doQuery(
                "POST",
                "http://www.ezbet.online/api/get_slip_list",
                data,
                function(result) {
                    console.log("success /get_slip_list = " + JSON.stringify(result));
                    if (!isNull(result.data.data)) {
                        for (var i = 0; i < result.data.data.length; i++) {
                            var slipData = result.data.data[i];

                            if (!isNull(matchIdSet[slipData.match_id])) {
                                continue;
                            }
                            matchIdSet[slipData.match_id] = true;

                            var date = getDateDisplay(slipData.start_time);
                            lastStartTime = slipData.start_time;
                            var slip = {
                                homeTeam: {
                                    name: ALL_TEAM[slipData.home_team].name,
                                    img: 'img/icon/team/' + ALL_TEAM[slipData.home_team].country + "_icon_crest_" + slipData.home_team + ".png",
                                    goal: slipData.home_goal
                                },
                                awayTeam: {
                                    name: ALL_TEAM[slipData.away_team].name,
                                    img: 'img/icon/team/' + ALL_TEAM[slipData.away_team].country + "_icon_crest_" + slipData.away_team + ".png",
                                    goal: slipData.away_goal
                                },
                                info: {
                                    matchId: slipData.match_id,
                                    matchFlag: slipData.match_flag,
                                    betFlag: slipData.bet_flag,
                                    absChange: Math.abs(slipData.total_return - slipData.total_bet),
                                    isProfit: (slipData.total_return >= slipData.total_bet),
                                    startTime: convertUnixToDisplayTime(slipData.start_time),
                                    matchTime: slipData.match_time
                                }
                            }
                            if (isNull($scope.data.slipDays[date])) {
                                $scope.data.slipDays[date] = [];
                            }
                            $scope.data.slipDays[date].push(slip);
                        }
                        $scope.data.hasMoreSlips = true;
                        //console.log(JSON.stringify($scope.data.slipDays));
                    } else {
                        $scope.data.hasMoreSlips = false;
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $ionicLoading.hide();
                },
                function(error) {
                    $ionicLoading.hide();
                    $scope.data.hasMoreSlips = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    console.log("error /get_slip_list: " + JSON.stringify(error));
                },
                3
            );
        };

        $ionicPlatform.on("resume", function() {
            if (UserService.isLoggedIn()) {
                onResume();
            }
        });

        var onResume = function() {
            console.log("onresume slips");
            $scope.data.slipDays = {};
            matchIdSet = {};

            $ionicLoading.show();
            getSlipList(null);
        };
    });
