
angular.module('starter')
    .controller('SlipsDetailCtrl', function ($scope, $ionicScrollDelegate, $timeout, $state, $stateParams, UserService, $http, $templateCache) {
        if (isNull($stateParams.match)) {
            console.log("null match");
            return;
        }

        $scope.data = {};

        $scope.data.match = $stateParams.match;

        $scope.data.slipOptions = {};
        $scope.data.slipDisplays = [];

        $scope.data.tabs = [
            {
                img: './img/bet.png',
                imgActive: './img/bet-active.png',
                id: 1
            },
            {
                img: './img/match.png',
                imgActive: './img/match-active.png',
                id: 2
            },
            {
                img: './img/stats.png',
                imgActive: './img/stats-active.png',
                id: 3
            },
            {
                img: './img/squad.png',
                imgActive: './img/squad-active.png',
                id: 4
            },
            {
                img: './img/media.png',
                imgActive: './img/video-active.png',
                id: 5
            }
        ];

        $scope.getRateDisplay = getRateDisplay2dp;

        $scope.selectTab = function (item) {
            $scope.data.tabSelected = item;
        };

        $scope.selectTab($scope.data.tabs[0]);

        var getSlipDetails = function() {
            var data = {
                "match_id": $scope.data.match.info.matchId,
                "token": UserService.getEzBetToken()
            };
            $http({
                method: "POST",
                url: "http://www.ezbet.online/api/get_slip_details",
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded"
                },
                data: toQueryString(data)
            }).then(function(result) {
                //console.log("success /get_slip_details = " + JSON.stringify(result));
                if ("result" in result.data && result.data.result === ResultCode.SUCCESS && !isNull(result.data.data) && !isNull(result.data.data.bet_options)) {
                    $scope.data.slipOptions = result.data.data.bet_options;
                    $scope.data.slipDisplays = [];
                    for (var i = 0; i < BetOptionOrder.length; i++) {
                        var type = BetOptionOrder[i];
                        if (isNull($scope.data.slipOptions[type])) {
                            continue;
                        }

                        console.log("options = " + type + ": " + JSON.stringify($scope.data.slipOptions[type]));

                        if (type == 1 || type == 6) {
                            continue;
                        }

                        //$scope.data.slipOptions[type].sort(getBetOptionSortingFunction(type));

                        //console.log("options = " + type + ": " + JSON.stringify($scope.data.betOptions[type]));
                        var display = {
                            betName: BetOptionName[type],
                            absChange: 0,
                            betFlag: 0,
                            betType: type
                        };
                        var isPending = false;
                        for (var j = 0; j < $scope.data.slipOptions[type].length; j++) {
                            display.absChange += $scope.data.slipOptions[type][j].bet_return - $scope.data.slipOptions[type][j].bet_amount;
                            if ($scope.data.slipOptions[type][j].bet_flag == 0) {
                                isPending = true;
                            }
                        }
                        if (isPending) {
                            display.betFlag = 0;
                            display.absChange = 0;
                        } else {
                            display.betFlag = (display.absChange >= 0) ? 2 : 3;
                            display.absChange = Math.abs(display.absChange);
                        }
                        $scope.data.slipDisplays.push(display);
                    }
                }
            }, function(error) {
                console.log("error /get_slip_details: " + JSON.stringify(error));
            });
        }

        getSlipDetails();
    })
    .directive('slipOption', function() {
        return {
            restrict: 'E',
            link: function(scope, element, attrs) {
                scope.getSlipTypeUrl = '';
                attrs.$observe('type', function(value) {
                    scope.getSlipTypeUrl = SlipOptionTemplateUrl[value];
                });
            },
            template: '<div><p ng-include="getSlipTypeUrl"></p></div>'
        }
    });
