angular.module('services', ['ionic'])

.service('UserService', function() {

    var hasGetUser = false;
    var token;
    var tokenExpiryTime;

    var setUser = function(backend, user_data) {
        window.localStorage.logged_in_user = JSON.stringify({"backend": backend, "user": user_data});
        token = user_data.token_info.token;
        tokenExpiryTime = user_data.token_info.expiry_time;
    };

    var getUser = function() {
        var user = JSON.parse(window.localStorage.logged_in_user || '{}');
        if (user.user) {
            token = user.user.token_info.token;
            tokenExpiryTime = user.user.token_info.expiry_time;
        }
        hasGetUser = true;
        return user;
    };

    var isLoggedIn = function() {
        return token != null &&  token != "";
    };

    var getEzBetToken = function() {
        if (!hasGetUser) {
            getUser();
        }
        return token;
    };

    var getEzBetTokenExpiryTime = function() {
        if (!hasGetUser) {
            getUser();
        }
        return tokenExpiryTime;
    };

    var setEzBetToken = function(ezBetToken) {
        token = ezBetToken;
    };

    var setEzBetTokenExpiryTime = function(expiryTime) {
        tokenExpiryTime = expiryTime;
    };

    var setUserProfile = function(profile) {
        window.localStorage.user_profile = JSON.stringify(profile);
    };

    var getUserProfile = function() {
        return JSON.parse(window.localStorage.user_profile || '{}');
    };

    var getUserVersion = function() {
        profile = getUserProfile();
        if (isNull(profile) || isNull(profile.version)) {
            return 0;
        }
        return profile.version;
    };

    var setUserData = function(userData) {
        window.localStorage.user_data = JSON.stringify(userData);
    };

    var getUserData = function() {
        return JSON.parse(window.localStorage.user_data || '{}');
    };

    var getUserDataVersion = function() {
        userData = getUserData();
        if (isNull(userData) || isNull(userData.version)) {
            return 0;
        }
        return userData.version;
    };

    var logOut = function() {
        window.localStorage.logged_in_user = '{}';
        window.localStorage.user_profile = '{}';
        window.localStorage.user_data = '{}';
        token = "";
        tokenExpiryTime = 0;
        hasGetUser = false;
    };

    return {
        getUser: getUser,
        setUser: setUser,
        isLoggedIn: isLoggedIn,
        getEzBetToken: getEzBetToken,
        getEzBetTokenExpiryTime: getEzBetTokenExpiryTime,
        setEzBetToken: setEzBetToken,
        setEzBetTokenExpiryTime: setEzBetTokenExpiryTime,
        setUserProfile: setUserProfile,
        getUserProfile: getUserProfile,
        getUserVersion: getUserVersion,
        setUserData: setUserData,
        getUserData: getUserData,
        getUserDataVersion: getUserDataVersion,
        logOut: logOut
    };
})
.service('HttpService', function($http, $timeout) {
    var doQuery = function(method, url, data, success, error, tries) {
        var count = tries;
        var redo = function(e) {
            count--;
            if (count > 0 || tries == -1) {
                $timeout(function() {
                    query();
                }, 500);
            } else {
                error(e);
            }
        };
        // add app version, yyyymmdd_vv
        data.app_version = "20170220_01";
        var params;
        if (method === "POST") {
            params = {
                method: "POST",
                url: url,
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded"
                },
                data: toQueryString(data)
            };
        } else if (method === "GET") {
            params = {
                method: "GET",
                url: url,
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded"
                }
            };
        }
        var query = function() {
            $http(params, {timeout: 5000}).then(function(result) {
                if ("result" in result.data && result.data.result === ResultCode.SUCCESS) {
                    success(result);
                } else {
                    redo(result);
                }
            }, function(e) {
                redo(e);
            });
        };
        query();
    };

    return {
        doQuery: doQuery
    };
});
