var ClientType = {
  CLIENT_WEB: 1,
  CLIENT_IOS: 2,
  CLIENT_ANDROID: 3
};

var ResultCode = {
    SUCCESS: 0,
    ERROR_PARAMS: 1,
    ERROR_TOKEN: 2,
    ERROR_TOKEN_EXPIRED: 3,
    ERROR_SIGNATURE: 4,
    ERROR_AUTH_CANCELLED: 5,
    ERROR_USER_NOT_EXIST: 6,
    ERROR_FB_TOKEN_INVALID: 7,
    ERROR_SERVER: 8,
    ERROR_MATCH_NOT_EXIST: 9,
    ERROR_BET_NOT_EXIST: 10,
    ERROR_BET_RATE_MISMATCH: 11,
    ERROR_NOT_ENOUGH_COIN: 12,
    ERROR_MATCH_HAPPENING: 13,
    ERROR_MATCH_DUPLICATE_BET: 14,
    ERROR_NEWS_NOT_EXIST: 15,
    ERROR_EMAIL_REQUIRED: 16,
    ERROR_ITEM_NOT_EXIST: 17,
    ERROR_UNACHIEVABLE: 18,
    ERROR_ACHIEVED: 19,
    ERROR_PROMO_ADD_HIMSELF: 20,
    ERROR_PROMO_CODE_INVALID: 21,
    ERROR_PROMO_ALREADY_ACCEPT_INVITATION: 22,
    ERROR_LOW_BET_AMOUNT: 23
};

var BonusClass = {
    BONUS_CLASS_MISSION: 1,
    BONUS_CLASS_TASK: 2,
};

var BonusTypeCode = {
    BONUS_MISSION_DAILY_LOGIN: 1,
    BONUS_MISSION_DAILY_BET_COUNT: 2,
    BONUS_MISSION_BET_SUCCESS_COUNT: 3,
    BONUS_MISSION_BET_FAIL_COUNT: 4,
    BONUS_MISSION_INVITE_FRIEND: 5,
    BONUS_MISSION_ACCEPT_FRIEND_INVITATION: 6
};

var EventType = {
    1: {
        name: "Kết quả",
        icon: "./img/icon/mission/noti-bet-result.png"
    },
    2: {
        name: "Chấp nhận lời mời",
        icon: "./img/icon/mission/noti-promo.png"
    }
};

var BonusType = {
    1: {
        name: "Lấy xu hàng ngày",
        description: 'biến thành 1000 xu nếu bạn có ít hơn."',
        icon: "./img/icon/mission/icon-calendar.png"
    },
    2: {
        name: "Lần cược hàng ngày",
		description: "Cược nhiều! Thắng nhiều hơn!",
        icon: "./img/icon/mission/icon-achieve.png"
    },
    3: {
        name: "Lần cược thắng",
		description: "Thắng nhiều! Được thưởng nhiều hơn!",
        icon: "./img/icon/mission/icon-cup.png"
    },
    4: {
        name: "Lần cược thua",
		description: "Thua! Không được thưởng!",
        icon: "./img/icon/mission/icon-text-BET.png"
    },
    5: {
        name: "Giới thiệu bạn bè",
		description: "Gửi mã cho bạn bè",
        icon: "./img/icon/mission/icon-letter-2.png"
    },
    6: {
        name: "",
        description: ""
    }
};

var DayInWeek = {
    0: "S",
    1: "M",
    2: "T",
    3: "W",
    4: "T",
    5: "F",
    6: "S"
};
var DayInWeekLong = {
    0: "Chủ nhật",
    1: "Thứ hai",
    2: "Thứ ba",
    3: "Thứ tư",
    4: "Thứ năm",
    5: "Thứ sáu",
    6: "Thứ bảy"
};

var AuthBackend = {
  FACEBOOK: "facebook",
  GOOGLE: "google-oauth2",
  TEST: "test"
};

var BetType = {
    BET_TYPE_EURO_HANDICAP: 1,
    BET_TYPE_TOTAL_GOAL: 2,
    BET_TYPE_HALF_RESULT: 3,
    BET_TYPE_CORRECT_SCORE: 4,
    BET_TYPE_OVER_UNDER_GOAL: 5,
    BET_TYPE_DOUBLE_CHANCE: 6,
    BET_TYPE_MATCH_RESULT: 7,
    BET_TYPE_FIRST_TEAM_SCORE: 8
};

var BetOptionOrder = [7, 3, 4, 2, 1, 5, 6, 8];
var BetOptionName = {
    7: "Kết quả chung cuộc",
    3: "Kết quả giữa hiệp",
    4: "Tỉ số",
    2: "Số bàn thắng",
    1: "Euro Handicap",
    5: "Số bàn thắng trên hoặc dưới",
    6: "Double Chance",
    8: "Đội đầu tiên ghi bàn"
};
var BetOptionTemplateUrl = {
    7: "./templates/bet_options/bet_match_result.html",
    3: "./templates/bet_options/bet_half_result.html",
    4: "./templates/bet_options/bet_correct_score.html",
    2: "./templates/bet_options/bet_total_goal.html",
    1: "./templates/bet_options/bet_euro_handicap.html",
    5: "./templates/bet_options/bet_over_under_goal.html",
    6: "./templates/bet_options/bet_double_chance.html",
    8: "./templates/bet_options/bet_first_team_score.html"
};
var SlipOptionTemplateUrl = {
    7: "./templates/slip_options/slip_match_result.html",
    3: "./templates/slip_options/slip_half_result.html",
    4: "./templates/slip_options/slip_correct_score.html",
    2: "./templates/slip_options/slip_total_goal.html",
    1: "./templates/slip_options/slip_euro_handicap.html",
    5: "./templates/slip_options/slip_over_under_goal.html",
    6: "./templates/slip_options/slip_double_chance.html",
    8: "./templates/slip_options/slip_first_team_score.html"
};

var LOGIN_EXPIRED_PERIOD = 24 * 60 * 60; // 1 day

function getCurrentTimestamp() {
    var date = new Date();
    return parseInt(date.getTime() / 1000);
}

function isSameDate(d1, d2) {
    return d1.getDate() == d2.getDate() && d1.getMonth() == d2.getMonth() && d1.getFullYear() == d2.getFullYear();
}
function getDateDisplay(time) {
    var date = new Date(time * 1000);
    var temp = new Date();
    if (isSameDate(date, temp)) {
        return "Hôm nay";
    }
    temp.setDate(temp.getDate() - 1);
    if (isSameDate(date, temp)) {
        return "Hôm qua";
    }
    return DayInWeekLong[date.getDay()] + ", " + date.getDate() + "/" + (date.getMonth() + 1);
}

function toQueryString(obj) {
	var parts = [];
	for (var i in obj) {
		if (obj.hasOwnProperty(i)) {
			parts.push(encodeURIComponent(i) + "=" + encodeURIComponent(obj[i]));
		}
	}
	return parts.join("&");
}

function isNull(obj) {
    if (obj === 0 || obj === "0") return false; // ugly logic, sorry
    return !obj || obj === 'null' || obj === 'undefined';
}

function paddingZero(num, size) {
    var s = num + "";
    while (s.length < size) {
        s = "0" + s;
    }
    return s;
}

function convertUnixToDisplayTime(time) {
    var date = new Date(time * 1000);
    var newDate = new Date(date.getTime());
    var hours = newDate.getHours();
    var minutes = newDate.getMinutes();
    return paddingZero(hours, 2) + ":" + paddingZero(minutes, 2);
    // return newDate.toLocaleTimeString('en-SG', { hour12: false, hour: "2-digit", minute: "2-digit"});
}

function getOffset() {
    return - (new Date().getTimezoneOffset());
}

function getRateDisplay2dp(rate) {
    if (rate % 100 === 0) {
        return rate / 100 + ".00";
    }
    if (rate % 10 === 0) {
        return rate / 100 + "0";
    }
    return rate / 100;
}

function isNumberValid(val) {
    if (!/^\d+$/.test(val)) {
        return false;
    }
    if (parseInt(val) == val) {
        return true;
    }
    return false;
}

function getBetOptionSortingFunction(type) {
    if (type == 7 || type == 3 || type == 8) {
        // sort odds in this order: home win, draw, away win
        return function(a, b) {
            if (a.value.result == 1) {
                return -1;
            } else if (a.value.result == 0) {
                return b.value.result == 1 ? 1 : -1;
            } else {
                return 1;
            }
        };
    } else if (type == 2) {
        // sort odds base on increasing number of goals
        return function(a, b) {
            return a.value.from - b.value.from;
        };
    } else if (type == 5) {
        return function(a, b) {
            var x = a.value.to == -1 ? a.value.from - 0.5 : a.value.to + 0.5;
            var y = b.value.to == -1 ? b.value.from - 0.5 : b.value.to + 0.5;
            if (x != y) return x - y;
            return a.value.to == -1 ? -1 : 1;
        }
    }
    return function(a, b) {
        return 0;
    }
}
